package com.microsoft.mobileexperiences.bing.httpthreadpool;

import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

public class HttpThreadPool extends ScheduledThreadPoolExecutor{	
	
	private static final int CORE_POOL_SIZE = 5;
	
    /* Get the instance of the singleton class.
    * 
    * @return <code>HttpThreadPool</code>.
    */
    public static HttpThreadPool instance() {
        return threadPoolInstance;
    }
   
    public void sendRequest(HttpRequest request, IHttpResult callback)
    {
    	request.setCallback(callback);
    	request.setFuture(submit(request));
    }
    
    public void scheduleRequest(HttpRequest request, IHttpResult callback, int delay) //delay in milliseconds
    {
    	request.setCallback(callback);
    	request.setFuture(this.schedule(request, delay, TimeUnit.MILLISECONDS));
    }
    
    /**
    * Constructor.
    * Make it private for singleton implementation.
    */
    private  HttpThreadPool() {   
    	super(CORE_POOL_SIZE);
    }    
   
    /**
    * Private instance of the singleton class
    */
    private static HttpThreadPool threadPoolInstance = new HttpThreadPool();  
   
}
